/**********************************************************************
 *  TCPץ륵Хץ (tcps.c)
 *        Ver 2.1 2007ǯ 3 6
 *                                 ¼ (Yukio Murayama)
 *
 *  ѵ
 *    ܥץϡTCP/IPץȥγؽڤӡͥåȥץ
 *    ߥ󥰤εǽ夵뤿ˤΤߡΤޤޡޤϡ
 *    ƻѤ뤳ȤǤޤܥץˤĤơˡΧǶػߤ
 *    Ƥ뤫ޤϡ¯ȿ褦ʲ¤ڤӡѤ
 *    ߤޤܥץ̵ݾڤǤԤܥץˤ
 *    ȯʤ»ˤĤƤǤ뤳ȤϤǤޤ
 **********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#ifdef FORK_SERVER
#include <signal.h>
#include <sys/wait.h>
#endif

#define BUFSIZE      8192
#define BUFSIZE2     32768
#define DEFAULT_PORT 5320

/* 롼ƥ󥰥ơ֥ɽ륳ޥ */
#ifdef __linux
#define COMMAND_ROUTE "/bin/netstat -rn"
#else
#define COMMAND_ROUTE "netstat -rn"
#endif

/* ARPơ֥ɽ륳ޥ */
#ifdef __linux
#define COMMAND_ARP "/sbin/arp -an"
#else
#define COMMAND_ARP "arp -an"
#endif

/* TCPͥơ֥ɽ륳ޥ */
#ifdef __linux
#define COMMAND_TCP "/bin/netstat -tn"
#else
#define COMMAND_TCP "netstat -n"
#endif

/* NICξɽ륳ޥ */
#ifdef __linux
#define COMMAND_NIC "/sbin/ifconfig -a"
#else
#define COMMAND_NIC "ifconfig -a"
#endif

enum {CMD_NAME, SRC_PORT};

int execute(char *command, char *buf, int bufmax);

#ifdef FORK_SERVER
void reaper()
{
  int status;
  wait(&status);
}
#endif

int main(int argc, char *argv[])
{
  struct sockaddr_in server;  /* ФΥɥ쥹                     */
  struct sockaddr_in client;  /* 饤ȤΥɥ쥹               */
  unsigned int len;           /* sockaddr_inĹ                    */
  int port;                   /* ФΥݡֹ                   */
  int s;                      /* åѥǥץ     */
  int s0;                     /* ͥդѥǥץ */

  /* ν(ݡֹ) */
  if (argc == 2) {
    if ((port = atoi(argv[SRC_PORT])) == 0) {
      struct servent *se;  /* ӥ */

      if ((se = getservbyname(argv[SRC_PORT], "tcp")) != NULL)
        port = (int) ntohs((u_int16_t) se->s_port);
      else {
        fprintf(stderr, "getservbyname error\n");
        exit(EXIT_FAILURE);
      }
    }
  } else
    port = DEFAULT_PORT;

  /* TCPǥåȤ򥪡ץ󤹤 */
  if ((s0 = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");
    exit(EXIT_FAILURE);
  }

  /* ФΥɥ쥹ꤹ */
  memset(&server, 0, sizeof server);
  server.sin_family      = AF_INET;
  server.sin_addr.s_addr = htonl(INADDR_ANY);
  server.sin_port        = htons(port);
  if (bind(s0, (struct sockaddr *) &server, sizeof server) < 0) {
    perror("bind");
    exit(EXIT_FAILURE);
  }

  /* ͥΩ׵ճ */
  if (listen(s0, 5) < 0) {
    perror("listen");
    exit(EXIT_FAILURE);
  }

#ifdef FORK_SERVER
  signal(SIGCHLD, (void *) reaper);
#endif

  /*
   * ͥդ롼 
   */
  while (1) {
    /* ͥս */
    len = sizeof client;
    if ((s = accept(s0, (struct sockaddr *) &client, &len)) < 0) {
      perror("accept");
      exit(EXIT_FAILURE);
    }
    /* ³饤ȤIPɥ쥹ɽ */
    printf("connected from '%s'\n", inet_ntoa(client.sin_addr));

#ifdef FORK_SERVER
    if (fork() != 0) {
      close(s);
      continue;
    }
    close(s0);
#endif

    /* нᥤ롼 */
    while (1) {
      char recv_buf[BUFSIZE];    /* Хåե               */
      char cmd1[BUFSIZE];        /* 1ܤΥޥ        */
      char cmd2[BUFSIZE];        /* 2ܤΥޥ        */
      int cn;                    /* ޥɤΥɿ */
      int i;                     /* ʸΥ         */
      char send_head[BUFSIZE];   /* ǡΥإå         */
      char send_data[BUFSIZE2];  /* Хåե               */
      int hn;                    /* إåΥХȿ       */
      int dn;                    /* ǡΥХȿ       */

      /* ޥɤμ */
      recv_buf[0] = '\0';
      for (i = 0; i < BUFSIZE - 1; i++) {
        if (recv(s, &recv_buf[i], 1, 0) <= 0)
          goto exit_loop;
        if (recv_buf[i] == '\n')  /* ñ̤Ǽ򤹤 */
          break;
      }
      recv_buf[i] = '\0';
      printf("receive '%s'\n", recv_buf);

      /* ޥɤν */
      if ((cn = sscanf(recv_buf, "%s%s", cmd1, cmd2)) <= 0)
        continue;
      if (cn == 2 && strcmp(cmd1, "show") == 0) {
        if (strcmp(cmd2, "route") == 0)
          dn = execute(COMMAND_ROUTE, send_data, BUFSIZE2);
        else if (strcmp(cmd2, "arp") == 0) 
          dn = execute(COMMAND_ARP, send_data, BUFSIZE2);
        else if (strcmp(cmd2, "tcp") == 0)
          dn = execute(COMMAND_TCP, send_data, BUFSIZE2);
        else if (strcmp(cmd2, "nic") == 0)
          dn = execute(COMMAND_NIC, send_data, BUFSIZE2);
        else
          dn = snprintf(send_data, BUFSIZE2, "parameter error '%s'\n"
                                           "show [route|arp|tcp|nic]\n", cmd2);
      } else {
        if (strcmp(cmd1, "quit") == 0)
          goto exit_loop;

        send_data[0] = '\0';
        if (cn != 1 && strcmp(cmd1, "help") != 0)
          snprintf(send_data, BUFSIZE2 - 1, "command error '%s'\n", cmd1);
        strncat(send_data, "Command:\n"
                           "  show route\n"
                           "  show arp\n"
                           "  show tcp\n"
                           "  show nic\n"
                           "  quit\n"
                           "  help\n", BUFSIZE2 - strlen(send_data) - 1);
        dn = strlen(send_data);
      }

      /* ץꥱإå */
      hn = snprintf(send_head, BUFSIZE - 1, "Content-Length: %d\n\n", dn);
      if (send(s, send_head, hn, 0) < 0)
        break;
      send_head[hn] = '\0';
      printf("%s\n", send_head);

      /* ץꥱǡ */
      if (send(s, send_data, dn, 0) < 0)
        break;
      printf("%s\n", send_data);
    }
  exit_loop:
    printf("connection closed.\n");
    close(s);
#ifdef FORK_SERVER
    return 0;
#endif
  }
  close(s0);

  return 0;
}

/*
 * int execute(char *command, char *buf, int bufmax);
 *
 * ǽ
 *     ޥɤ¹ԤϷ̤Хåե˳Ǽ
 *  
 *     char *command;  ¹Ԥ륳ޥ
 *     char *buf;      Ϸ̤ǼХåե
 *     int bufmax;     Хåե礭
 * 
 *     int             Хåե˳Ǽʸ
 */
int execute(char *command, char *buf, int bufmax)
{
  FILE *fp;  /* եݥ         */
  int i;     /* ϤǡΥХȿ */

  if ((fp = popen(command, "r")) == NULL) {
    perror(command);
    i = snprintf(buf, BUFSIZE, "server error: '%s' cannot execute.\n", command);
  } else {
    i = 0;
    while (i < bufmax - 1 && fscanf(fp, "%c", &buf[i]) == 1) 
      i++;
    buf[i] = '\0';
    pclose(fp);
  }
  return i;
}
