/**********************************************************************
 *  UDPTvT[o (udps.c)
 *        Ver 2.1 2007N 3 6
 *                                E R (Yukio Murayama)
 *
 *  gp
 *    {vÓATCP/IPvgR̊wKAyсAlbg[Nv
 *    O~ŐZ\コ邽߂ɂ̂݁Â܂܁A܂́AC
 *    Ďgp邱Ƃł܂B{vOɂāA@ŋ֎~
 *    Ă邩A܂́AǑɔ悤ȉAyсAgp
 *    ~܂B{vO͖ۏ؂łB҂͖{vOɂ
 *    ĔȂ鑹QɂĂӔC邱Ƃ͂ł܂B
 **********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define BUFSIZE      32768
#define MSGSIZE      1024
#define DEFAULT_PORT 5320

/* [eBOe[u\R}h */
#ifdef __linux
#define COMMAND_ROUTE "/bin/netstat -rn"
#else
#define COMMAND_ROUTE "netstat -rn"
#endif

/* ARPe[u\R}h */
#ifdef __linux
#define COMMAND_ARP "/sbin/arp -an"
#else
#define COMMAND_ARP "arp -an"
#endif

/* TCPRlNVe[u\R}h */
#ifdef __linux
#define COMMAND_TCP "/bin/netstat -tn"
#else
#define COMMAND_TCP "netstat -n"
#endif

/* NIC̏\R}h */
#ifdef __linux
#define COMMAND_NIC "/sbin/ifconfig -a"
#else
#define COMMAND_NIC "ifconfig -a"
#endif

enum {CMD_NAME, DST_PORT};

int execute(char *command, char *buf, int bufmax);

int main(int argc, char *argv[])
{
  struct sockaddr_in server;  /* T[õAhX           */
  struct sockaddr_in client;  /* NCAg̃AhX     */
  unsigned int len;           /* sockaddr_in̒          */
  int port;                   /* T[õ|[gԍ         */
  int s;                      /* \PbgfBXNv^     */
  int cn;                     /* MR}h̃[h */
  int sn;                     /* MbZ[W̃oCg   */
  int rn;                     /* MbZ[W̃oCg   */
  int i;                      /* [vϐ                 */
  char cmd1[BUFSIZE];         /* 1[hڂ̃R}h        */
  char cmd2[BUFSIZE];         /* 2[hڂ̃R}h        */
  char recv_buf[BUFSIZE];     /* Mobt@               */
  char send_buf[BUFSIZE];     /* Mobt@               */

  /* ̏(|[gԍ) */
  if (argc == 2) {
    if ((port = atoi(argv[DST_PORT])) == 0) {
      struct servent *se;     /* T[rX */

      if ((se = getservbyname(argv[DST_PORT], "udp")) != NULL)
        port = (int) ntohs((u_int16_t) se->s_port);
      else {
        fprintf(stderr, "getservbyname error\n");
        exit(EXIT_FAILURE);
      }
    }
  } else
    port = DEFAULT_PORT;

  /* UDPŃ\PbgI[v */
  if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    perror("socket");
    exit(EXIT_FAILURE);
  }

  /* T[õAhXݒ肷 */
  memset(&server, 0, sizeof server);
  server.sin_family        = AF_INET;
  server.sin_addr.s_addr   = htonl(INADDR_ANY);
  server.sin_port          = htons(port);
  if (bind(s, (struct sockaddr *) &server, sizeof server) < 0) {
    perror("bind");
    exit(EXIT_FAILURE);
  }

  /* T[oC[` */
  while ((rn = recvfrom(s, recv_buf, BUFSIZE - 1, 0,
                        (struct sockaddr *) &client,
                        (len = sizeof client, &len))) >= 0) {
    recv_buf[rn] = '\0';
    printf("receive from '%s'\n", inet_ntoa(client.sin_addr));
    printf("receive data '%s'\n", recv_buf);

    /* MR}h̏ */
    if ((cn = sscanf(recv_buf, "%s%s", cmd1, cmd2)) <= 0)
      sn = 0; /* continue; */
    else if (cn == 2 && strcmp(cmd1, "show") == 0) {
      if (strcmp(cmd2, "route") == 0)
        sn = execute(COMMAND_ROUTE, send_buf, BUFSIZE);
      else if (strcmp(cmd2, "arp") == 0)
        sn = execute(COMMAND_ARP, send_buf, BUFSIZE);
      else if (strcmp(cmd2, "tcp") == 0)
        sn = execute(COMMAND_TCP, send_buf, BUFSIZE);
      else if (strcmp(cmd2, "nic") == 0)
        sn = execute(COMMAND_NIC, send_buf, BUFSIZE);
      else
        sn = snprintf(send_buf, BUFSIZE, "parameter error '%s'\n"
                                         "show [route|arp|tcp|nic]\n", cmd2);
    } else {
      if (strcmp(cmd1, "quit") == 0)
        break;

      send_buf[0] = '\0';
      if (cn != 1 && strcmp(cmd1, "help") != 0)
        snprintf(send_buf, BUFSIZE, "command error '%s'\n", cmd1);
      strncat(send_buf, "Command:\n"
                        "  show route\n"
                        "  show arp\n"
                        "  show tcp\n"
                        "  show nic\n"
                        "  quit\n"
                        "  help\n", BUFSIZE - strlen(send_buf) - 1);
      sn = strlen(send_buf);
    }

    /* bZ[WM[v (ŌɕKMSGSIZẼpPbg𑗐M) */
    for (i = 0; i <= sn; i += MSGSIZE) {
      int size;  /* M郁bZ[W̃TCY */

      if (sn - i > MSGSIZE)
        size = MSGSIZE;
      else if (sn - i <= 0)
        size = 0;
      else
        size = sn - i;
      if (sendto(s,&send_buf[i],size,0,(struct sockaddr *)&client,len) < 0) {
        perror("sendto");
        exit(EXIT_FAILURE);
      }
    }
    printf("%s", send_buf);
  }
  close(s);

  return 0;
}

/*
 * int execute(char *command, char *buf, int bufmax);
 *
 * @\
 *     R}hsAo͌ʂobt@Ɋi[
 * 
 *     char *command;  sR}h
 *     char *buf;      o͌ʂi[obt@
 *     int bufmax;     obt@̑傫
 * ߂l
 *     int             obt@Ɋi[
 */
int execute(char *command, char *buf, int bufmax)
{
  FILE *fp;  /* t@C|C^         */
  int i;     /* ͂f[^̃oCg */

  if ((fp = popen(command, "r")) == NULL) {
    perror(command);
    i = snprintf(buf, BUFSIZE, "server error: '%s' cannot execute.\n", command);
  } else {
    i = 0;
    while (i < bufmax - 1 && fscanf(fp, "%c", &buf[i]) == 1) 
      i++;
    buf[i] = '\0';
    pclose(fp);
  }
  return i;
}
