/**********************************************************************
 *  UDP|[gXLvO (scanport_udp.c)
 *        Ver 2.0 2004N 7 10
 *                                E R (Yukio Murayama)
 *
 *  gp
 *    {vÓATCP/IPvgR̊wKAyсAlbg[Nv
 *    O~ŐZ\コ邽߂ɂ̂݁Â܂܁A܂́AC
 *    Ďgp邱Ƃł܂B{vOɂāA@ŋ֎~
 *    Ă邩A܂́AǑɔ悤ȉAyсAgp
 *    ~܂B{vO͖ۏ؂łB҂͖{vOɂ
 *    ĔȂ鑹QɂĂӔC邱Ƃ͂ł܂B
 **********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>
#define  __FAVOR_BSD
#include <netinet/udp.h>

#define CHKADDRESS(_saddr_) \
        {\
          unsigned char *p = (unsigned char *) &(_saddr_);\
          if ((p[0] == 127)\
           || (p[0] == 10)\
           || (p[0] == 172 && 16 <= p[1] && p[1] <= 31)\
           || (p[0] == 192 && p[1] == 168))\
            ;\
          else {\
            fprintf(stderr, "IP address error.\n");\
            exit(EXIT_FAILURE);\
          }\
        }

#define MAXBUFF 8192

enum {CMD_NAME, DST_IP, START_PORT, LAST_PORT};
enum {CONNECT, NOCONNECT};

int udpportscan(u_int32_t dst_ip, int dst_port, int send_sd, int recv_sd);

int main(int argc, char *argv[])
{
  int recv_sd;       /* MpfBXNv^                      */
  int send_sd;       /* MpfBXNv^                      */
  u_int32_t dst_ip;  /* I_IPAhX (lbg[NoCgI[_) */
  int end_port;      /* XLJn|[gԍ                    */
  int start_port;    /* XLI|[gԍ                    */
  int dst_port;      /* XL|[gԍ                    */

  /* R}hC̐̃`FbN */
  if (argc != 4) {
    fprintf(stderr, "usage: %s dst_ip start_port last_port\n", argv[CMD_NAME]);
    exit(EXIT_FAILURE);
  }

  /* R}hClZbg */
  dst_ip     = inet_addr(argv[DST_IP]);
  start_port = atoi(argv[START_PORT]);
  end_port   = atoi(argv[LAST_PORT]);

  CHKADDRESS(dst_ip);

  /* MpUDP\Pbg̃I[v */
  if ((send_sd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    perror("socket(SOCK_DGRAM)");
    exit(EXIT_FAILURE);
  }

  /* Mpraw\Pbg̃I[v */
  if ((recv_sd = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP)) < 0) {
    perror("socket(SOCK_RAW)");
    exit(EXIT_FAILURE);
  }

  /* XL|[gC[v */
  for (dst_port = start_port; dst_port <= end_port; dst_port++) {
    printf("Scan Port %d\r", dst_port);
    fflush(stdout);

    if (udpportscan(dst_ip, dst_port, send_sd, recv_sd) == CONNECT) {
      /* select^CAEgƂ */
      struct servent *se;  /* T[rX */

      se = getservbyport(htons(dst_port), "udp");
      printf("%5d %-20s\n", dst_port, (se==NULL) ? "unknown" : se->s_name);
    }
    usleep(10 * 1000);
  }
  close(send_sd);
  close(recv_sd);

  return 0;
}

/*
 * int udpportscan(u_int32_t dst_ip, int dst_port)
 * @\
 *     w肵IPAhXA|[gԍUDPŒʐMł邩ׂB
 *  
 *     u_int32_t dst_ip;  MIPAhX (lbg[NoCgI[_)
 *     int dst_port;      M|[gԍ
 * ߂l
 *     int                CONNECT  ... |[gJĂ
 *                        NOCONNECT .. |[g܂Ă
 */
int udpportscan(u_int32_t dst_ip, int dst_port, int send_sd, int recv_sd)
{
  struct sockaddr_in send_sa;  /* M̃AhX      */
  char buff[MAXBUFF];          /* pPbgMpobt@    */
  struct timeval tv;           /* select̃^CAEg  */
  fd_set select_fd;            /* selectprbg}bv      */

  /* MAhX̐ݒ */
  memset(&send_sa, 0, sizeof send_sa);
  send_sa.sin_family      = AF_INET;
  send_sa.sin_addr.s_addr = dst_ip;
  send_sa.sin_port        = htons(dst_port);

  /* UDPpPbg̑M (wb_̂ݑMAf[^0oCg) */
  sendto(send_sd, NULL, 0, 0, (struct sockaddr *) &send_sa, sizeof send_sa);

  /* select̃^CAEg̐ݒ */
  tv.tv_sec  = 1;
  tv.tv_usec = 0;
  while (1) {
    /* selectŌfBXNv^̐ݒ */
    FD_ZERO(&select_fd);
    FD_SET(recv_sd, &select_fd);

    if (select(recv_sd + 1, &select_fd, NULL, NULL, &tv) > 0) {
      struct icmp *icmp;   /* icmpwb_                    */
      struct ip *ip;       /* IPwb_\                */
      int ihlen;           /* IPwb_̒                */
      struct ip *ip2;      /* ICMPf[^IPwb_\  */
      int ihlen2;          /* ICMPf[^IPwb_̒  */
      struct udphdr *udp;  /* |[gԍ                    */

      /* ICMPpPbg̎M (56 = 20(IP) + 8(ICMP) + 20(IP) + 8(UDP)) */
      if (recvfrom(recv_sd, buff, MAXBUFF, 0, NULL, NULL) < 56)
        continue;

      ip     = (struct ip *) buff;
      ihlen  = ip->ip_hl << 2;
      icmp   = (struct icmp *) ((char *) ip + ihlen);
      ip2    = (struct ip *) icmp->icmp_data;
      ihlen2 = ip2->ip_hl << 2;
      udp    = (struct udphdr *) ((char *) ip2 + ihlen2);

      /* MpPbg|[gBs\Ȃwhile[v𔲂 */
      if ((ip->ip_src.s_addr == send_sa.sin_addr.s_addr)
          && (icmp->icmp_type == ICMP_UNREACH)
          && (icmp->icmp_code == ICMP_UNREACH_PORT)
          && (ip2->ip_p == IPPROTO_UDP)
          && (udp->uh_dport == send_sa.sin_port))
        break;
    } else
      return CONNECT;
  }
  return NOCONNECT;
}
