/**********************************************************************
 *  TCPTvT[ovO (tcpv6s.c)
 *        Ver 2.1 2007N 3 6
 *                                E R (Yukio Murayama)
 *
 *  gp
 *    {vÓATCP/IPvgR̊wKAyсAlbg[Nv
 *    O~ŐZ\コ邽߂ɂ̂݁Â܂܁A܂́AC
 *    Ďgp邱Ƃł܂B{vOɂāA@ŋ֎~
 *    Ă邩A܂́AǑɔ悤ȉAyсAgp
 *    ~܂B{vO͖ۏ؂łB҂͖{vOɂ
 *    ĔȂ鑹QɂĂӔC邱Ƃ͂ł܂B
 **********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <time.h>
#ifdef FORK_SERVER
#include <signal.h>
#include <sys/wait.h>
#endif

#define BUFSIZE      8192
#define BUFSIZE2     32768
#define DEFAULT_PORT "5320"
#define MAXSOCK      16

/* [eBOe[u\R}h */
#ifdef __linux
#define COMMAND_ROUTE "/bin/netstat -rn"
#else
#define COMMAND_ROUTE "netstat -rn"
#endif

/* ARPe[u\R}h */
#ifdef __linux
#define COMMAND_ARP "/sbin/arp -an"
#else
#define COMMAND_ARP "arp -an"
#endif

/* TCPRlNVe[u\R}h */
#ifdef __linux
#define COMMAND_TCP "/bin/netstat -tn"
#else
#define COMMAND_TCP "netstat -tn"
#endif

/* NIC̏\R}h */
#ifdef __linux
#define COMMAND_NIC "/sbin/ifconfig -a"
#else
#define COMMAND_NIC "ifconfig -a"
#endif

enum {CMD_NAME, SRC_PORT};

int execute(char *command, char *buf, int bufmax);

#ifdef FORK_SERVER
void reaper()
{
  int status;
  wait(&status);
}
#endif

int main(int argc, char *argv[])
{
  struct sockaddr_storage client;  /* NCAg̃AhX                 */
  struct addrinfo hints;           /* AhX擾̂߂̐ݒ               */
  struct addrinfo *res0;           /* T[õAhX(擪|C^)     */
  struct addrinfo *res;            /* T[õAhX                   */
  unsigned int len;                /* sockaddr_in̒                      */
  int s0[MAXSOCK];                 /* RlNV󂯕tfBXNv^     */
  int s;                           /* bZ[WMpfBXNv^       */
  int s_num;                       /* RlNV󂯕tfBXNv^̐ */
  int s_max;                       /* fBXNv^̍ől                 */
  char ip[NI_MAXHOST];             /* IPAhX̕\Li[       */
  int i;                           /* [vϐ                             */
  int error;                       /* getaddrinfõG[R[h              */

  /* addrinfo\̂ւ̐ݒ */
  memset(&hints, 0, sizeof hints);
  hints.ai_family   = PF_UNSPEC;
  hints.ai_socktype = SOCK_STREAM;
  hints.ai_flags    = AI_PASSIVE;

  /* IPAhX̐ݒ(DNSւ̖₢킹) */
  error = getaddrinfo(NULL, (argc == 2) ? argv[SRC_PORT] : DEFAULT_PORT,
                      &hints, &res0);
  if (error) {
    fprintf(stderr, "'%s' %s\n", (argc == 2) ? argv[SRC_PORT] : DEFAULT_PORT,
            gai_strerror(error));
    exit(EXIT_FAILURE);
  }

  /* RlNVmvtJn[v */
  s_num = s_max = 0;
  for (res = res0; res && s_num < MAXSOCK; res = res->ai_next) {
    /* TCPŃ\PbgI[v */
    if ((s0[s_num] = socket(res->ai_family, res->ai_socktype, res->ai_protocol))
         > 0) {
      /* T[õAhXݒ肷 */
      if (bind(s0[s_num], res->ai_addr, res->ai_addrlen) < 0) {
        close(s0[s_num]);
        continue;
      }
      /* RlNVmvtJn */
      if (listen(s0[s_num], SOMAXCONN) < 0) {
        close(s0[s_num]);
        continue;
      }
      if (s_max < s0[s_num])
        s_max = s0[s_num];
      s_num++;
    }
  }
  if (s_num == 0) {
    perror("socket");
    exit(EXIT_FAILURE);
  }

#ifdef FORK_SERVER
  signal(SIGCHLD, (void *) reaper);
#endif

  /*
   * RlNV󂯕t[v 
   */
  while (1) {
    fd_set readfd;  /* selectŌfBXNv^ */

    /* RlNVt */
    FD_ZERO(&readfd);
    for (i = 0; i < s_num; i++)
      FD_SET(s0[i], &readfd);
    if (select(s_max + 1, &readfd, NULL, NULL, NULL) <= 0) {
      fprintf(stderr, "Timeout\n");
      break;
    }
    for (i = 0; i < s_num; i++)
      if (FD_ISSET(s0[i], &readfd))
        break;
    len = sizeof client;
    if ((s = accept(s0[i], (struct sockaddr *) &client, &len)) < 0) {
      perror("accept");
      exit(EXIT_FAILURE);
    }

    /* ڑNCAg̃AhXƃvgR̎ނ̕\ */
    if (getnameinfo((struct sockaddr *) &client, len, ip, sizeof ip, NULL, 0,
                    NI_NUMERICHOST)) {
      fprintf(stderr, "getnameinfo error\n");
      exit(EXIT_FAILURE);
    }
    printf("connected from '%s'", ip);
    if (client.ss_family == AF_INET6)
      printf("by IPv6\n");
    else if (client.ss_family == AF_INET)
      printf("by IPv4\n");
    else
      printf("unkown protocol\n");

#ifdef FORK_SERVER
    if (fork() != 0) {
      close(s);
      continue;
    }
    for (i = 0; i < s_num; i++)
      close(s0[i]);
#endif

    /* T[oC[` */
    while (1) {
      char recv_buf[BUFSIZE];    /* Mobt@               */
      char cmd1[BUFSIZE];        /* 1[hڂ̃R}h        */
      char cmd2[BUFSIZE];        /* 2[hڂ̃R}h        */
      int rn;                    /* MbZ[W̃oCg   */
      int cn;                    /* MR}h̃[h */
      int i;                     /* M̃JEg         */
      char send_head[BUFSIZE];   /* Mf[^̃wb_         */
      char send_data[BUFSIZE2];  /* Mobt@               */
      int hn;                    /* Mwb_̃oCg       */
      int dn;                    /* Mf[^̃oCg       */

      /* R}h̎M */
      recv_buf[0] = '\0';
      for (i = 0; i < BUFSIZE - 1; i++) {
        if ((rn = recv(s, &recv_buf[i], 1, 0)) <= 0)
          goto exit_loop;
        if (recv_buf[i] == '\n')  /* sPʂŎM */
          break;
      }
      recv_buf[i] = '\0';
      printf("receive '%s'\n", recv_buf);

      /* MR}h̏ */
      if ((cn = sscanf(recv_buf, "%s%s", cmd1, cmd2)) <= 0)
        continue;
      if (cn == 2 && strcmp(cmd1, "show") == 0) {
        if (strcmp(cmd2, "route") == 0)
          dn = execute(COMMAND_ROUTE, send_data, BUFSIZE2);
        else if (strcmp(cmd2, "arp") == 0) 
          dn = execute(COMMAND_ARP, send_data, BUFSIZE2);
        else if (strcmp(cmd2, "tcp") == 0)
          dn = execute(COMMAND_TCP, send_data, BUFSIZE2);
        else if (strcmp(cmd2, "nic") == 0)
          dn = execute(COMMAND_NIC, send_data, BUFSIZE2);
        else
          dn = snprintf(send_data, BUFSIZE2, "parameter error '%s'\n"
                                           "show [route|arp|tcp|nic]\n", cmd2);
      } else {
        if (strcmp(cmd1, "quit") == 0)
          goto exit_loop;

        send_data[0] = '\0';
        if (cn != 1 && strcmp(cmd1, "help") != 0)
          snprintf(send_data, BUFSIZE2 - 1, "command error '%s'\n", cmd1);
        strncat(send_data, "Command:\n"
                           "  show route\n"
                           "  show arp\n"
                           "  show tcp\n"
                           "  show nic\n"
                           "  quit\n"
                           "  help\n", BUFSIZE2 - strlen(send_data) - 1);
        dn = strlen(send_data);
      }

      /* AvP[Vwb_̑M */
      hn = snprintf(send_head, BUFSIZE - 1, "Content-Length: %d\n\n", dn);
      if (send(s, send_head, hn, 0) < 0)
        break;
      send_head[hn] = '\0';
      printf("%s\n", send_head);

      /* AvP[Vf[^̑M */
      if (send(s, send_data, dn, 0) < 0)
        break;
      send_data[dn] = '\0';
      printf("%s\n", send_data);
    }
  exit_loop:
    printf("connection closed.\n");
    close(s);
#ifdef FORK_SERVER
    return 0;
#endif
  }
  for (i = 0; i < s_num; i++)
    close(s0[i]);
  freeaddrinfo(res0);

  return 0;
}

/*
 * int execute(char *command, char *buf, int bufmax);
 *
 * @\
 *     R}hsAo͌ʂobt@Ɋi[
 *  
 *     char *command;  sR}h
 *     char *buf;      o͌ʂi[obt@
 *     int bufmax;     obt@̑傫
 * ߂l
 *     int             obt@Ɋi[
 */
int execute(char *command, char *buf, int bufmax)
{
  FILE *fp;  /* t@C|C^         */
  int i;     /* ͂f[^̃oCg */

  if ((fp = popen(command, "r")) == NULL) {
    perror(command);
    i = snprintf(buf, BUFSIZE, "server error: '%s' cannot execute.\n", command);
  } else {
    i = 0;
    while (i < bufmax - 1 && fscanf(fp, "%c", &buf[i]) == 1)
      i++;
    pclose(fp);
  }
  return i;
}
